/**
 * @namespace WORKAREA.addToRegistryButton
 */
WORKAREA.registerModule('addToRegistryButton', (function () {
    'use strict';

    var loadDialog = function(event) {
            var $button = $(event.target),
                $form = $button.closest('.product-details').find('.product-details__add-to-cart-form'),
                data = $form.serialize();

            event.preventDefault();

            if (! $form.valid()) { return; }

            WORKAREA.dialog.createFromUrl($button.attr('href') + '?' + data);
        },

        setupButtons = function($placeholder, user) {
            var template = JST['workarea/storefront/registries/templates/add_to_registry_button'],
                $addToRegistryButton;

            if (!user.logged_in || user.registry_count < 1) { return; }

            $addToRegistryButton = $(template(user));

            $placeholder.replaceWith($addToRegistryButton);
            $addToRegistryButton.on('click', loadDialog);
        },

        /**
         * @method
         * @name init
         * @memberof WORKAREA.addToRegistryButton
         */
        init = function ($scope) {
            var $placeholder = $('[data-add-to-registry-button]', $scope);

            if (_.isEmpty($placeholder)) { return; }

            WORKAREA.currentUser.gettingUserData.done(
                _.partial(setupButtons, $placeholder)
            );
        };

    return {
        init: init
    };
}()));
