/**
 * @namespace WORKAREA.copyRegistryUrlButton
 */

WORKAREA.registerModule('copyRegistryUrlButton', (function () {
    'use strict';

    var copyURL = function (event) {
            var registryUrl = $('[data-copy-registry-url-button]')[0].dataset.registryUrl,
                temporaryId = 'temporary_copy_field',
                temporaryInput = '<input type="text" class="visually-hidden" id="' + temporaryId + '" value="' + registryUrl + '">';

            event.preventDefault();

            $('body').append(temporaryInput);
            $('#' + temporaryId).select();

            try {
                document.execCommand('copy');
                WORKAREA.messages.insertMessage(
                    I18n.t('workarea.storefront.flash_messages.registry_url_copied'),
                    'success'
                );
            } catch(err) {
                WORKAREA.messages.insertMessage(
                    I18n.t('workarea.storefront.flash_messages.registry_url_not_copied', { error: err.message }),
                    'error'
                );
            } finally {
                $(temporaryId).remove();
            }
        },

        /**
         * @method
         * @name init
         * @memberof WORKAREA.copyRegistryUrlButton
         */

        init = function ($scope) {
            var $button = $('[data-copy-registry-url-button]', $scope);

            if (_.isEmpty($button)) { return; }

            $button.on('click', copyURL);
        };

    return {
        init: init
    };
}()));
