/**
 * @namespace WORKAREA.toggleRegistryAddress
 */
WORKAREA.registerModule('toggleRegistryAddress', (function () {
    'use strict';

    var toggleRegistryAddress = function ($option, $scope) {
            var option = $option.data('registryAddressOption').option;
            if (_.isEmpty($option)) { return; }
            
            var $shippingAddressFields = $('.checkout-addresses__fields', $scope),
                $registryAddressFields = $('[data-registry-checkout-addresses-fields]', $scope);

            if (option === 'ship_to_registrant') {
                $shippingAddressFields.addClass('hidden');
                $registryAddressFields.removeClass('hidden');
                toggleSameAsShipping($scope, false)
            }

            else if (option === 'ship_to_another_address') {
                $shippingAddressFields.removeClass('hidden');
                $registryAddressFields.addClass('hidden');
                toggleSameAsShipping($scope, true)
            }
        },

        toggleSameAsShipping = function($scope, checked) {
            var $sameAsShippingCheckbox = $('#same_as_shipping', $scope),
                $sameAsShippingContainer = $sameAsShippingCheckbox.parent();

            $sameAsShippingCheckbox.prop('checked', checked)
                .prop('disabled', !checked)
                .trigger('change');

            if (checked) {
              $sameAsShippingContainer.removeClass('hidden');
            } else {
              $sameAsShippingContainer.addClass('hidden');
            }
        },

        /**
         * @method
         * @name init
         * @memberof WORKAREA.toggleRegistryAddress
         */
        init = function ($scope) {
            var $scope = $('.checkout-addresses__section--shipping', $scope)

            $('[data-registry-address-option]', $scope).on('click', function(event) {
                toggleRegistryAddress($(event.currentTarget), $scope);
            });
        };

    return {
        init: init
    };
}()));
