module Workarea
  class Admin::RegistriesController < Admin::ApplicationController
    required_permissions :orders

    before_action :find_registry, except: :index
    after_action :track_index_filters, only: :index

    def index
      search = Search::AdminRegistries.new(
        params.merge(autocomplete: request.xhr?)
      )

      @search = Admin::SearchViewModel.new(search, view_model_options)
    end

    # Exists to support search result linkage
    def show
      redirect_to registries_path(q: "id:#{@registry.id}")
    end

    private

    def find_registry
      model = Registry.find(params[:id])
      @registry = Admin::RegistryViewModel.new(model, view_model_options)
    end
  end
end
