module Workarea
  module Storefront
    class Users::RegistrySharesController < Storefront::ApplicationController
      before_action :find_registry_share

      def new
      end

      def create
        if @registry_share.save
          flash[:success] = t(
            'workarea.storefront.flash_messages.registry_share_message_sent',
            recipient: @registry_share.friendly_to
          )
          RegistriesMailer.share(@registry_share.id.to_s).deliver_later
          redirect_to users_registry_path(@registry_share.registry_id)
        else
          render :new
        end
      end

      private

      def find_registry_share
        model = Registry::Share.new(share_params)
        @registry_share = RegistryShareViewModel.wrap(model, view_model_options)
      end

      def share_params
        params.permit(
          :url,
          :registry_id,
          :registry_name,
          :to_email,
          :to_name,
          :from_email,
          :from_name,
          :message
        )
      end
    end
  end
end
