module Workarea
  module Storefront
    class Users::RegistryThanksController < Storefront::ApplicationController
      before_action :find_registry_thank

      def new
      end

      def create
        if @registry_thank.save
          flash[:success] = t(
            'workarea.storefront.flash_messages.registry_thank_message_sent',
            recipient: @registry_thank.friendly_to
          )
          RegistriesMailer.thank(@registry_thank.id.to_s).deliver_later
          redirect_to users_registry_path(@registry_thank.registry_id, state: 'unpurchased')
        else
          render :new
        end
      end

      private

      def find_registry_thank
        model = Registry::Thank.new(thank_params)
        @registry_thank = RegistryThankViewModel.wrap(model, view_model_options)
      end

      def thank_params
        params.permit(
          :registry_id,
          :to_email,
          :to_name,
          :from_email,
          :from_name,
          :message
        )
      end
    end
  end
end
