module Workarea
  module Admin
    class ActiveRegistriesMailer < Admin::ApplicationMailer
      def report(emails)
        report = ActiveRegistriesReport.new
        report.generate
        attachments['report.csv'] = File.read(report.file_path)
        mail(
            to: emails,
            from: Workarea.config.email_from,
            subject: t('workarea.admin.active_registries_mailer.report.subject'),
        )
      end
    end
  end
end
