module Workarea
  module Storefront
    class RegistriesMailer < ApplicationMailer
      def creation(id)
        @registry = RegistryViewModel.wrap(Registry.find(id))
        @content = Content::Email.find_content('registry_creation')

        mail(
          to: @registry.email,
          from: Workarea.config.email_from,
          subject: t('workarea.storefront.email.registries.creation.subject')
        )
      end

      def share(id)
        @share = RegistryShareViewModel.wrap(Registry::Share.find(id))
        @content = Content::Email.find_content('registry_share')

        mail(
          to: @share.friendly_to,
          from: Workarea.config.email_from,
          reply_to: @share.from,
          subject: t('workarea.storefront.email.registries.share.subject', from: @share.friendly_from)
        )
      end

      def thank(id)
        @thank = RegistryThankViewModel.wrap(Registry::Thank.find(id))
        @content = Content::Email.find_content('registry_thank')

        mail(
          to: @thank.friendly_to,
          from: Workarea.config.email_from,
          reply_to: @thank.from,
          subject: t('workarea.storefront.email.registries.thank.subject', from: @thank.friendly_from)
        )
      end

      def gift_receipt(order_id)
        order = Order.find(order_id)
        @order = Storefront::OrderViewModel.wrap(order)
        @content = Content::Email.find_content('registry_gift_receipt')

        mail(
          to: @order.registry_email,
          from: Workarea.config.email_from,
          subject: t('workarea.storefront.email.registries.gift_receipt.subject')
        )
      end
    end
  end
end
