module Workarea
  class Registry::PublicSearch
    attr_reader :query

    def initialize(query)
      @query    = query
    end

    def results
      regex = /^#{Regexp.quote(query)}/i
      criteria = [
        { name: regex },
        { id: query }, # we don't want partial matching on id
        { email: query } # we don't want partial matching on email
      ]

      Workarea::Registry.where(
        privacy: 'public',
        '$or' => criteria
      )
    end
  end
end
