module Workarea
  class Registry
    class Thank
      include ApplicationDocument

      field :to_name, type: String
      field :to_email, type: String
      field :from_name, type: String
      field :from_email, type: String
      field :message, type: String
      field :registry_id, type: String

      validates :to_email, presence: true, email: true
      validates :from_email, presence: true, email: true
      validates :message, length: {
        maximum: :max_email_thank_message_length
      }

      private

      def max_email_thank_message_length
        Workarea.config.max_email_registry_thanks_message_length
      end
    end
  end
end
