module Workarea
  class RegistryContentSeeds
    def perform
      puts 'Adding registry content...'

      create_system_page
      create_email_content
    end

    def create_system_page
      content = Content.for('registries')
      content.blocks.create!(
        area: 'default',
        type: 'html',
        data: { html: default_page_html }
      )
    end

    def create_email_content
      Content::Email.create!(
        type: 'registry_creation',
        content: 'Congratulations on your new registry!'
      )

      Content::Email.create!(
        type: 'registry_share',
        content: 'Check out my Registry.'
      )

      Content::Email.create!(
        type: 'registry_thank',
        content: 'Thank you for your Gift.'
      )

      Content::Email.create!(
        type: 'registry_gift_receipt',
        content: 'The following items have been purchased for your Registry.'
      )
    end

    def default_page_html
      <<-TEXT
        <h1>Registry Welcome Page</h1>
        <p>
          This page will act as a portal for users to begin and continue their Registry Journey.
        </p>
      TEXT
    end
  end
end
