module Workarea
  module Storefront
    class RegistryEmailViewModel < ApplicationViewModel
      def to
        to_email
      end

      def from
        from_email
      end

      def from_name
        model.from_name || options[:user].try(:name)
      end

      def from_email
        model.from_email || options[:user].try(:email)
      end

      def friendly_from
        if from_name.blank?
          from_email
        else
          from_name
        end
      end

      def friendly_to
        if to_name.present?
          "#{to_name} (#{to_email})"
        else
          to_email
        end
      end
    end
  end
end
