module Workarea
  class UpdateRegistryItems
    include Sidekiq::Worker
    include Sidekiq::CallbacksWorker

    sidekiq_options enqueue_on: { Order => :place }, queue: 'high'

    def perform(order_id)
      order = Order.find(order_id)

      order.items.each do |item|
        next unless item.registry_item?
        registry = Workarea::Registry.find(item.registry_id)
        registry.mark_item_received(item)
        registry.add_purchased_item(
          {
            sku: item.sku,
            product_id: item.product_id,
            quantity: item.quantity,
            purchased_by: order.email,
            total_price: item.total_price
          }
        )
      end
    end
  end
end