Workarea::Storefront::Engine.routes.draw do
  scope '(:locale)', constraints: Workarea::I18n.routes_constraint do
    namespace :users do
      resources :registries do

        collection do
          resources :items, only: [:new, :create], as: :registry_items, controller: :registry_items
          resources :shares, only: [:new, :create], as: :registry_shares, controller: :registry_shares
          resources :thanks, only: [:new, :create], as: :registry_thanks, controller: :registry_thanks
        end

        resources :items, only: [:update, :destroy], controller: :registry_items
      end
    end

    resources :registries, only: [:show, :index]

    get 'registry/search', to: 'registries#search'
  end
end

Workarea::Admin::Engine.routes.draw do
  scope '(:locale)', constraints: Workarea::I18n.routes_constraint do
    resources :registries, only: [:index, :show]

    resource :report do
      get :active_registries
      post :export_active_registries
    end
  end
end
